Package org.apache.commons.math3.optim

# Class BaseMultivariateOptimizer<PAIR>

java.lang.Object
org.apache.commons.math3.optim.BaseOptimizer<PAIR>
org.apache.commons.math3.optim.BaseMultivariateOptimizer<PAIR>

Type Parameters:
  `PAIR` - Type of the point/value pair returned by the optimization algorithm.

Direct Known Subclasses:
  `BaseMultiStartMultivariateOptimizer`, `MultivariateOptimizer`, `MultivariateVectorOptimizer`

public abstract class BaseMultivariateOptimizer<PAIR> extends BaseOptimizer<PAIR>
Base class for implementing optimizers for multivariate functions. It contains the boiler-plate code for initial guess and bounds specifications. It is not a "user" class.

Since:
  3.1

## Field Summary

### Fields inherited from class org.apache.commons.math3.optim.BaseOptimizer

`evaluations, iterations`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`BaseMultivariateOptimizer(ConvergenceChecker<PAIR> checker)`

## Method Summary

Modifier and Type
Method
Description
`double[]`
`getLowerBound()`
`double[]`
`getStartPoint()`
Gets the initial guess.
`double[]`
`getUpperBound()`
`PAIR`
`optimize(OptimizationData... optData)`
Stores data and performs the optimization.
`protected void`
`parseOptimizationData(OptimizationData... optData)`
Scans the list of (required and optional) optimization data that characterize the problem.

### Methods inherited from class org.apache.commons.math3.optim.BaseOptimizer

`doOptimize, getConvergenceChecker, getEvaluations, getIterations, getMaxEvaluations, getMaxIterations, incrementEvaluationCount, incrementIterationCount, optimize`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### BaseMultivariateOptimizer

protected BaseMultivariateOptimizer(ConvergenceChecker<PAIR> checker)

Parameters:
  `checker` - Convergence checker.

## Method Details

### optimize

public PAIR optimize(OptimizationData... optData)
Stores data and performs the optimization.

The list of parameters is open-ended so that sub-classes can extend it with arguments specific to their concrete implementations.

When the method is called multiple times, instance data is overwritten only when actually present in the list of arguments: when not specified, data set in a previous call is retained (and thus is optional in subsequent calls).

Important note: Subclasses must override `BaseOptimizer.parseOptimizationData(OptimizationData[])` if they need to register their own options; but then, they must also call `super.parseOptimizationData(optData)` within that method.

Overrides:
  `optimize` in class `BaseOptimizer<PAIR>`
Parameters:
  `optData` - Optimization data. In addition to those documented in `BaseOptimizer`, this method will register the following data:
  - `InitialGuess`
  - `SimpleBounds`
Returns:
  a point/value pair that satisfies the convergence criteria.

### parseOptimizationData

protected void parseOptimizationData(OptimizationData... optData)
Scans the list of (required and optional) optimization data that characterize the problem.

Overrides:
  `parseOptimizationData` in class `BaseOptimizer<PAIR>`
Parameters:
  `optData` - Optimization data. The following data will be looked for:
  - `InitialGuess`
  - `SimpleBounds`

### getStartPoint

public double[] getStartPoint()
Gets the initial guess.

Returns:
  the initial guess, or `null` if not set.

### getLowerBound

public double[] getLowerBound()

Returns:
  the lower bounds, or `null` if not set.

### getUpperBound

public double[] getUpperBound()

Returns:
  the upper bounds, or `null` if not set.